<template>
  <section class="top-slider" id="about">
    <Flicking
      :options="flickingOptions"
      class="top-slider__slider"
      :plugins="flickingPlugins"
    >
      <div v-for="(panel, i) in panels" :key="i" class="top-slider__panel">
        <img
          :src="panel.imageUrl"
          class="top-slider__panel__image"
          :alt="`Top slider photo ${i}`"
        />
        <h1 class="big-title top-slider__panel__heading">
          <strong>{{ panel.heading }}</strong>
        </h1>
        <h2 class="top-slider__panel__subheading">{{ panel.subheading }}</h2>
      </div>
      <div
        slot="viewport"
        class="flicking-pagination top-slider__pagination"
      ></div>
    </Flicking>
    <CircleLink hash="#projects" class="top-slider__to-content-button">
      <i
        class="fa-solid fa-chevron-down top-slider__to-content-button__icon"
      ></i>
    </CircleLink>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import CircleLink from "@/components/CircleLink.vue";
import type { FlickingOptions } from "@egjs/flicking";
import { Pagination } from "@egjs/flicking-plugins";
import "@egjs/flicking-plugins/dist/pagination.css";
import { AutoPlay } from "@egjs/flicking-plugins";

@Component({ components: { CircleLink } })
export default class HeaderSlider extends Vue {
  flickingOptions: Partial<FlickingOptions> = {
    horizontal: false,
    panelsPerView: 1,
    align: "prev",
    circular: true,
    disableOnInit: true,
    duration: 1000,
  };
  flickingPlugins = [
    new Pagination({ type: "bullet" }),
    new AutoPlay({ duration: 2000, direction: "NEXT", stopOnHover: false }),
  ];
  panels: { heading: string; subheading: string; imageUrl: string }[] = [
    {
      heading: "simple & modern",
      subheading: "we make the world beautiful everyday",
      imageUrl: "/src/assets/tu-tram-pham-202263.png",
    },
    {
      heading: "smart & concise",
      subheading: "we do not waste your time",
      imageUrl: "/src/assets/tu-tram-pham-202263.png",
    },
    {
      heading: "fast & furious",
      subheading: "is a dead movie franchise",
      imageUrl: "/src/assets/tu-tram-pham-202263.png",
    },
    {
      heading: "simple & modern",
      subheading: "we make the world beauriful everyday",
      imageUrl: "/src/assets/tu-tram-pham-202263.png",
    },
    {
      heading: "simple & modern",
      subheading: "we make the world beauriful everyday",
      imageUrl: "/src/assets/tu-tram-pham-202263.png",
    },
  ];
}
</script>

<style lang="scss" scoped>
.top-slider {
  width: 100%;
  height: 100vh;
  position: relative;

  &__slider {
    width: 100%;
    height: 100%;
  }

  &__panel {
    position: relative;
    background: linear-gradient(243.43deg, #7e5aff 16.9%, #55b7ff 83.27%);
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    gap: 20px;
    color: $white;

    &__image {
      display: block;
      position: absolute;
      top: 0;
      left: 0;
      height: 100%;
      width: 100%;
      object-fit: cover;
    }

    &__heading {
      position: relative;
      font-size: 80px;
      line-height: 1.2;
      letter-spacing: 0.1em;
      margin: 0;
    }

    &__subheading {
      position: relative;
      font-size: 18px;
      line-height: 1.2;
      letter-spacing: 0.3em;
    }
  }

  &__pagination {
    position: absolute;
    top: auto;
    bottom: 0;
    right: 52px;
    left: auto;
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: flex-end;
    gap: 40px;
  }

  &__to-content-button {
    position: absolute;
    bottom: 50px;
    left: 50%;
    transform: translate(-50%, 0);
    z-index: 2;

    &__icon {
      color: $white;
      display: block;
      font-size: 10px;
      line-height: 1.73;
    }
  }
}
</style>
